import xml.dom.minidom

class XML4DCitiesParser:
    
    def getText(self, nodelist):
        rc = ""
        for node in nodelist:
            if node.nodeType == node.TEXT_NODE:
                rc = rc + node.data
        return rc

    #retorna un python dictionary apartir del fitxer de configuracio XML donat a la ruta File
    def getConfigFromXMLFile(self, File):
        try:
            doc = xml.dom.minidom.parse(File)
        except IOError, e:
            #si no troba cap xml a la ruta File retorna la configuracio per defecte
            return {'carrer_principal':[[(-10,0),(-5,0),(0,0),(5,0),(10,0)]],
                    'city_center_x':3, 'city_center_y':3,'f':0.6,'factor':0.4,
                    'num_expancions':10,'long_min':4, 'long_max':8,
                    'angle_var':5,'allargament':3, 'shappingmin':2}
        
        carrer_principal = eval(self.getText((doc.getElementsByTagName("carrer_principal")[0]).childNodes))
        city_center_x = int(self.getText((doc.getElementsByTagName("city_center_x")[0]).childNodes))
        city_center_y = int(self.getText((doc.getElementsByTagName("city_center_y")[0]).childNodes))
        f = float(self.getText((doc.getElementsByTagName("f")[0]).childNodes))
        factor = float(self.getText((doc.getElementsByTagName("factor")[0]).childNodes))
        num_expancions = int(self.getText((doc.getElementsByTagName("num_expancions")[0]).childNodes))
        long_min = int(self.getText((doc.getElementsByTagName("long_min")[0]).childNodes))
        long_max = int(self.getText((doc.getElementsByTagName("long_max")[0]).childNodes))
        angle_var = int(self.getText((doc.getElementsByTagName("angle_var")[0]).childNodes))
        allargament = int(self.getText((doc.getElementsByTagName("allargament")[0]).childNodes))
        shappingmin = int(self.getText((doc.getElementsByTagName("shappingmin")[0]).childNodes))
        return {'carrer_principal':carrer_principal,'city_center_x':city_center_x,
                'city_center_y':city_center_y,'f':f,'factor':factor,
                'num_expancions':num_expancions,'long_min':long_min,
                'long_max':long_max,'angle_var':angle_var,'allargament':allargament,
                'shappingmin':shappingmin}

    #crea un xml amb la configuracio Config
    def putConfigToXMLFile(self, File, Config):
        f = open(File, 'w')    
        document =  '<?xml version="1.0"?>\n'
        document += '<StreetExpantion>\n'
        document += '\t<carrer_principal>'+str(Config['carrer_principal'])+'</carrer_principal>\n'
        document += '\t<city_center_x>'+str(Config['city_center_x'])+'</city_center_x>\n'
        document += '\t<city_center_y>'+str(Config['city_center_y'])+'</city_center_y>\n'
        document += '\t<f>'+str(Config['f'])+'</f>\n'
        document += '\t<factor>'+str(Config['factor'])+'</factor>\n'
        document += '\t<num_expancions>'+str(Config['num_expancions'])+'</num_expancions>\n'  
        document += '\t<long_min>'+str(Config['long_min'])+'</long_min>\n'
        document += '\t<long_max>'+str(Config['long_max'])+'</long_max>\n'
        document += '\t<angle_var>'+str(Config['angle_var'])+'</angle_var>\n'
        document += '\t<allargament>'+str(Config['allargament'])+'</allargament>\n'
        document += '\t<shappingmin>'+str(Config['shappingmin'])+'</shappingmin>\n'
        document += '</StreetExpantion>\n'
        f.write(document)
        f.close()

