import hou

from controlVariables import *
from uENode import *
from stdNetworkNodes import *

from lots import *
from buildings import *
import houStreets

# ===========================================================
#                uE4DCitiesNodeFactory
# ===========================================================
class uE4DCitiesNodeFactory:
	def __init__(self, blocks):
		self.__createContainer()
		self.blocks = blocks
	def getContainer(self):
		return self.geo
	def __createContainer(self):
		self.geo = hou.node('/obj').createNode('geo')
		controlVariables.geo = self.geo
		#delete the file node
		for n in self.geo.children():
			n.destroy()
	def createNode(self,nodeName):
		if (nodeName == 'majorRoads'): 
			outputNode = uE4DCitiesMajorRoads(self.blocks)
		elif (nodeName == 'minorRoads'): 
			outputNode = DicedMinorRoads()
		elif (nodeName == 'blocks'): 
			outputNode = Blocks()
		elif (nodeName == 'lots'):
			outputNode = Lots()
		elif (nodeName == 'buildings'):
			outputNode = Buildings()
		elif (nodeName == 'finalAppearance'): 
			outputNode = FinalAppearance()
		elif (nodeName == 'floor'): 
			outputNode = Floor()
		elif (nodeName == 'filter'): 
			outputNode = ConstructionFilter()
		elif (nodeName == 'stats'):
			outputNode = Stats()
		outputNode.setContainer(self.geo)
		outputNode.construct()
		return outputNode
	def finishConstruction(self):
		self.geo.setDisplayFlag(True)
		for n in self.geo.children():
			n.moveToGoodPosition()			
		for n in hou.node('/obj').children():
			n.moveToGoodPosition()

# ===========================================================
#                LoadMapMajorRoads
# ===========================================================
class uE4DCitiesMajorRoads(urbanEngineNode):
	def getNodeName(self):
		return 'uE4DCitiesMajorRoads'

	def __init__(self, blocks):
		urbanEngineNode.__init__(self, False)
		self.blocks = blocks

	def construct(self):
		self.first = houStreets.blocks(self.geo, self.blocks)
		self.last = self.first