#execfile('c:/users/markus/desktop/wxmain.py')
#execfile('L:/dagush/Citadel/urbanEngine/4DCities/wxmain.py')
#!/usr/bin/env python

import sys
urbanEnginePath = 'L:/dagush/Citadel/urbanEngine/'
the4DCitiesPath = urbanEnginePath + '4DCities/'
urbanEngineDemosPath = urbanEnginePath + 'Demos/'
sys.path.append(urbanEnginePath + "4DCities")
sys.path.append(urbanEnginePath + 'FileReaders')
sys.path.append(urbanEnginePath + 'Network')
sys.path.append(urbanEnginePath + 'buildingEngine')
sys.path.append(urbanEnginePath + 'FileReaders')
#sys.path.append("c:/users/markus/desktop/4DCities")
import network
import houStreets
from readInput import *
from uE4DCitiesNetwork import *

import wx
import os
from wx.lib import masked

def showCity(city):
	if (hou.node('obj/geo1')):
		hou.node('obj/geo1').destroy()
	container = hou.node("/obj").createNode("geo")
	carrers = city.getCarrers()
	houStreets.streets(container, carrers)

class CityExpantion(wx.Frame):   
    #make a frame, inherits wx.Frame
    def __init__(self, parent, title, size, XMLConfigFile=''):

        #inicialitza la ciutat la ciutat
        self.XMLparser = XML4DCitiesParser.XML4DCitiesParser()
        self.config = self.XMLparser.getConfigFromXMLFile(XMLConfigFile)
        self.city = streets.City(self.config['city_center_x'], self.config['city_center_y'], self.config['f'],
                                 self.config['factor'], self.config['angle_var'], self.config['long_min'],
                                 self.config['long_max'],self.config['allargament'], self.config['shappingmin'])
        self.city.createInitialCity(self.config['carrer_principal'])
        
        # create a frame, no parent, default to wxID_ANY
        wx.Frame.__init__(self, parent, wx.ID_ANY, title, wx.DefaultPosition, size)
        #self.SetBackgroundColour("green")
        panel = wx.Panel( self, -1 )

        #title
        font = wx.Font(10, wx.NORMAL, wx.NORMAL, wx.BOLD)
        title = wx.StaticText(panel, -1, "4DCities")
        title.SetFont(font)
        
        initial_city_text = wx.StaticText( panel,-1, "Initial city:" )
        self.carrer_principal = wx.TextCtrl(self, -1, str(self.config['carrer_principal']), size=(150, 50), style=wx.TE_MULTILINE)
        #self.carrer_principal  = masked.TextCtrl( self, -1, str(self.config['carrer_principal']), validRegex   = '^\[\[\(\d+,\d+\)\]\]')       
        
        #Initial node parameters
        city_center_text = wx.StaticText( panel,-1, "City center:" )
        x_text = wx.StaticText( panel,-1, "x " )
        self.city_center_x = masked.NumCtrl( panel, value=self.config['city_center_x'], integerWidth=4, allowNegative=True, groupDigits = False )
        y_text = wx.StaticText( panel,-1, "  y " )
        self.city_center_y = masked.NumCtrl( panel, value=self.config['city_center_y'], integerWidth=4, allowNegative=True, groupDigits = False )
        #text d'ajuda
        self.city_center_x.SetToolTip(wx.ToolTip("punt que marca el centre de la ciutat"))
        self.city_center_y.SetToolTip(wx.ToolTip("punt que marca el centre de la ciutat"))
        
        f_text = wx.StaticText( panel,-1, "f:" )    
        self.f = masked.Ctrl( panel, value=self.config['f'], integerWidth=5, fractionWidth=2, groupDigits = False, controlType=masked.controlTypes.NUMBER )
        self.f.SetToolTip(wx.ToolTip("concentracio respecte el centre. Utilitzat alhora d'escollir el node de sortida de la expancio\n (com mes petit menys concentracio al centre)"))

        factor_text = wx.StaticText( panel,-1, "Factor:" )
        self.factor = masked.Ctrl( panel, value=self.config['factor'], integerWidth=5, fractionWidth=2, groupDigits = False, controlType=masked.controlTypes.NUMBER )        
        self.factor.SetToolTip(wx.ToolTip('relacio entre els vertex amb valencia 2 i els de 4 factor utilitzat alhora d\'escollir el node de sortida de la expancio'))

        #Expantion parameters
        num_expancions_text = wx.StaticText( panel,-1, "Expantions for year: " )
        self.num_expancions = masked.NumCtrl( panel, value=self.config['num_expancions'], integerWidth=4, allowNegative=False, groupDigits = False )        
        self.num_expancions.SetToolTip(wx.ToolTip('numero d\'expancions per iteracio o any'))

        angle_var_text = wx.StaticText( panel,-1, "Angle variation:" )
        self.angle_var = masked.NumCtrl( panel, value=self.config['angle_var'], integerWidth=4, allowNegative=False, groupDigits = False )        
        self.angle_var.SetToolTip(wx.ToolTip('variacio del angle de sortida en graus al expandir un carrer (ex: -30 +30)'))

        long_text = wx.StaticText( panel,-1, "Segment length:" )
        long_min_text = wx.StaticText( panel,-1, "min " )
        self.long_min = masked.NumCtrl( panel, value=self.config['long_min'], integerWidth=4, allowNegative=False, groupDigits = False )        
        long_max_text = wx.StaticText( panel,-1, "  max " )
        self.long_max = masked.NumCtrl( panel, value=self.config['long_max'], integerWidth=4, allowNegative=False, groupDigits = False )
        self.long_min.SetToolTip(wx.ToolTip('longitud minima d\'un tram de carrer nou'))
        self.long_max.SetToolTip(wx.ToolTip('longitud maxima d\'un tram de carrer nou'))

        #Adapt parameters
        allargament_text = wx.StaticText( panel,-1, "Stretch:" )
        self.allargament = masked.NumCtrl( panel, value=self.config['allargament'], integerWidth=4, allowNegative=False, groupDigits = False )        
        self.allargament.SetToolTip(wx.ToolTip('alhora de calcular les interseccion es permet un allargament de x unitats'))

        shappingmin_text = wx.StaticText( panel,-1, "Shappingmin:" )
        self.shappingmin = masked.NumCtrl( panel, value=self.config['shappingmin'], integerWidth=4, allowNegative=False, groupDigits = False )        
        self.shappingmin.SetToolTip(wx.ToolTip('alhora de expandir un carrer si existeix un vertex a x unitats s\'utilitza aquest en comptes de crear el nou vertex'))
     
        self.load_button = wx.Button(panel, -1, 'Load Config')
        self.load_button.SetToolTip(wx.ToolTip('Carrega el fitxer de configuracio XML especificat'))
        self.save_button = wx.Button(panel, -1, 'Save Config')
        self.save_button.SetToolTip(wx.ToolTip('Guarda la configuracio en un fitxer XML'))
        self.apply_button = wx.Button(panel, -1, 'Apply Config')
        self.apply_button.SetToolTip(wx.ToolTip('Aplica la configuracio actual'))
        self.expand_button = wx.Button(panel, -1, 'Expand city')
        self.expand_button.SetToolTip(wx.ToolTip('Expandeix un any mes la ciutat actual') )                                   
        self.build_button = wx.Button(panel, -1, 'Build')
        self.build_button.SetToolTip(wx.ToolTip('Construeix edificis en les illes'))                                
        self.reset_button = wx.Button(panel, -1, 'Reset')
        self.reset_button.SetToolTip(wx.ToolTip('Desfa totes les expancions deixant la ciutat inicial amb la configuracio actual'))                                  

        #posicio en celles
        grid = wx.FlexGridSizer( 0, 2, 0, 0 )
        grid.Add( initial_city_text, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        grid.Add( self.carrer_principal, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        grid.Add( city_center_text, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        hbox = wx.BoxSizer( wx.HORIZONTAL )
        hbox.Add( x_text, 0, wx.ALIGN_LEFT|wx.ALL, 0)
        hbox.Add( self.city_center_x, 0, wx.ALIGN_LEFT|wx.ALL, 0)
        hbox.Add( y_text, 0, wx.ALIGN_LEFT|wx.ALL, 0)
        hbox.Add( self.city_center_y, 0, wx.ALIGN_LEFT|wx.ALL, 0)        
        grid.Add( hbox, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        
        grid.Add( f_text, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        grid.Add( self.f, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        
        grid.Add( factor_text, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        grid.Add( self.factor, 0, wx.ALIGN_LEFT|wx.ALL, 5 )

        grid.Add( num_expancions_text, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        grid.Add( self.num_expancions, 0, wx.ALIGN_LEFT|wx.ALL, 5 )

        grid.Add( angle_var_text, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        grid.Add( self.angle_var, 0, wx.ALIGN_LEFT|wx.ALL, 5 )

        grid.Add( long_text, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        hbox2 = wx.BoxSizer( wx.HORIZONTAL )
        hbox2.Add( long_min_text, 0, wx.ALIGN_LEFT|wx.ALL, 0)
        hbox2.Add( self.long_min, 0, wx.ALIGN_LEFT|wx.ALL, 0)
        hbox2.Add( long_max_text, 0, wx.ALIGN_LEFT|wx.ALL, 0)
        hbox2.Add( self.long_max, 0, wx.ALIGN_LEFT|wx.ALL, 0)                
        grid.Add( hbox2, 0, wx.ALIGN_LEFT|wx.ALL, 5 )

        grid.Add( allargament_text, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        grid.Add( self.allargament, 0, wx.ALIGN_LEFT|wx.ALL, 5 )

        grid.Add( shappingmin_text, 0, wx.ALIGN_LEFT|wx.ALL, 5 )
        grid.Add( self.shappingmin, 0, wx.ALIGN_LEFT|wx.ALL, 5 )

        button_box = wx.BoxSizer( wx.HORIZONTAL )
        button_box.Add( self.load_button, 0, wx.ALIGN_LEFT|wx.ALL, 0 )
        button_box.Add( self.save_button, 0, wx.ALIGN_LEFT|wx.ALL, 0 )
        button_box.Add( self.apply_button, 0, wx.ALIGN_LEFT|wx.ALL, 0 )

        button_box2 = wx.BoxSizer( wx.HORIZONTAL )
        button_box2.Add( self.expand_button, 0, wx.ALIGN_LEFT|wx.ALL, 0 )
        button_box2.Add( self.build_button, 0, wx.ALIGN_LEFT|wx.ALL, 0 )        
        button_box2.Add( self.reset_button, 0, wx.ALIGN_LEFT|wx.ALL, 0 )
        
        self.outer_box = wx.BoxSizer( wx.VERTICAL )
        self.outer_box.Add( title, 0, wx.ALIGN_CENTER|wx.ALL, 10 )
        self.outer_box.Add( grid, 0, wx.ALIGN_LEFT|wx.ALL, 10 )
        self.outer_box.Add( button_box, 0, wx.ALIGN_RIGHT|wx.ALL, 10 )
        self.outer_box.Add( button_box2, 0, wx.ALIGN_RIGHT|wx.ALL, 10 )
        
        panel.SetAutoLayout( True )
        panel.SetSizer( self.outer_box )
        self.outer_box.Fit( panel )
        panel.Move( (0,0) )
        self.panel = panel

        #events
        self.Bind(wx.EVT_BUTTON, self.OnLoadConfig, self.load_button )
        self.Bind(wx.EVT_BUTTON, self.OnSaveConfig, self.save_button )
        self.Bind(wx.EVT_BUTTON, self.OnApply, self.apply_button )
        self.Bind(wx.EVT_BUTTON, self.OnStreetExpantion, self.expand_button )
        self.Bind(wx.EVT_BUTTON, self.OnBuiding, self.build_button )
        self.Bind(wx.EVT_BUTTON, self.OnReset, self.reset_button )
        #self.Bind(masked.EVT_NUM, self.OnSetIntWidth, self.integerwidth )

	showCity(self.city)

        self.Show(True)

    def OnLoadConfig(self,event):
        wildcard = "XML file (*.xml)|*.xml|"\
           "All files (*.*)|*.*"
        
        dlg = wx.FileDialog(
            self, message="Choose a file",
            defaultDir=os.getcwd(), 
            defaultFile="",
            wildcard=wildcard,
            style=wx.OPEN | wx.CHANGE_DIR
            )

        if dlg.ShowModal() == wx.ID_OK:
            # This returns a Python list of files that were selected.
            paths = dlg.GetPaths()
            path = paths[0]
        
            self.config = self.XMLparser.getConfigFromXMLFile(path)
            self.f.SetValue(self.config['f'])
            self.angle_var.SetValue(self.config['angle_var']) 
            self.long_min.SetValue(self.config['long_min'])
            self.long_max.SetValue(self.config['long_max'])
            self.allargament.SetValue(self.config['allargament'])
            self.shappingmin.SetValue(self.config['shappingmin'])
            self.factor.SetValue(self.config['factor'])
            self.city_center_x.SetValue(self.config['city_center_x'])
            self.city_center_y.SetValue(self.config['city_center_y'])
            self.num_expancions.SetValue(self.config['num_expancions'])
            self.carrer_principal.SetValue(str(self.config['carrer_principal']))
            
        dlg.Destroy()

    def OnSaveConfig(self,event):
        wildcard = "XML file (*.xml)|*.xml|"\
           "All files (*.*)|*.*"
        
        dlg = wx.FileDialog(
            self, message="Save file as ...", defaultDir=os.getcwd(), 
            defaultFile="", wildcard=wildcard, style=wx.SAVE
            )

        dlg.SetFilterIndex(2)

        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            print path
        
        self.XMLparser.putConfigToXMLFile(path, self.config)

        dlg.Destroy()

    def OnApply(self,event):
        long_min = self.long_min.GetValue()  
        long_max = self.long_max.GetValue() 
        if long_min > long_max:
            dlg = wx.MessageDialog(
                self, 
                'Minimun lenght can\'t be higher than maximum!', 
                'Alert', 
                wx.OK | wx.ICON_INFORMATION) 
            dlg.ShowModal() 
            dlg.Destroy() 
        else:
            self.config['carrer_principal'] = eval(self.carrer_principal.GetValue())
            self.config['f'] = self.f.GetValue()
            self.config['num_expancions'] = self.num_expancions.GetValue()
            self.config['angle_var'] = self.angle_var.GetValue() 
            self.config['long_min'] = long_min  
            self.config['long_max'] = long_max   
            self.config['allargament'] = self.allargament.GetValue()   
            self.config['shappingmin'] = self.shappingmin.GetValue()  
            self.config['factor'] = self.factor.GetValue() 
            self.config['city_center_x'], self.config['city_center_y'] = self.city_center_x.GetValue(), self.city_center_y.GetValue() 
            self.city.updateParameters(self.config['city_center_x'], self.config['city_center_y'], self.config['f'],
                                       self.config['factor'], self.config['angle_var'], self.config['long_min'],
                                       self.config['long_max'], self.config['allargament'], self.config['shappingmin'])

    def OnReset(self, event):
        self.city = streets.City(self.config['city_center_x'], self.config['city_center_y'], self.config['f'],
                                 self.config['factor'], self.config['angle_var'], self.config['long_min'],
                                 self.config['long_max'],self.config['allargament'], self.config['shappingmin'])
        self.city.createInitialCity(self.config['carrer_principal']) 
	showCity(self.city)

    def OnStreetExpantion(self, event):
	#expandeix iterativament
	result = self.city.makeExpation(self.config['num_expancions'])
	if result == False:
		print 'Error en l\'expancio'
  
	carrers = self.city.getCarrers()
	print "--CARRERS--"
	print carrers
	showCity(self.city)

    def OnBuiding(self, event):
        llista_illes = self.city.getIlles()
        print "-- ILLES --"
        print llista_illes
	print "-- Cleaning --"
	if (hou.node('obj/geo1')):
		hou.node('obj/geo1').destroy()
	#controlVariables.path = urbanEngineDemosPath
	#print "controlVariables.path:", controlVariables.path
	readInput(urbanEngineDemosPath, the4DCitiesPath + 'uE_4DCitiesConfig.xml')
	print "-- Going Hou --"
	uE = uE4DCitiesNodeFactory(llista_illes)
	network.createGeometry(uE)


# =======================
# ====    Main       ====
# =======================

import streets
#import houStreets
import XML4DCitiesParser
      
application = wx.PySimpleApp()
window = CityExpantion(None,'', (307,492), the4DCitiesPath + '4DCitiesConfig.xml')
application.MainLoop()

